﻿<?php
if (!defined("FUNC_FILE")) die("Illegal File Access");

class dt
{
	function sDate($str, $dateTime=false)
	{
		if(!$dateTime)
			$dateTime = $this->rDateTime();
		$arr = $this->dateTimIsArr($this->cDateTime($dateTime));
		
		$sDate = '';
		for($i=0; $i<strlen($str); $i++)
		{
			switch($str[$i])
			{
				case 'a':// am or pm
						if($arr['hour'] >= 0 && $arr['hour'] <= 11) $sDate .= 'صبح';
						else $sDate .= 'عصر';								
						break;
					
				case 'A':// am or pm
						if($arr['hour'] >= 0 && $arr['hour'] <= 11) $sDate .= 'ق.ظ';
						else $sDate .= 'ب.ظ';								
						break;
						
				case 'B':// what older
						$sDate .= $this->dateDifference($dateTime, $this->rDateTime());			
						break;
					
				case 'd':// day 00-31
						$sDate .= $arr['day'];
						break;
					
				case 'F':// name of month 
						$sDate .= $this->rArray($arr['month'], 'jNameOfMonths');
						break;
					
				case 'g':// hour 0-12 
						if($arr['hour'] >= 13 && $arr['hour'] <= 23) $sDate .= $arr['hour']-12;
						elseif($arr['hour'] == 0) $sDate .= 12;
						else $sDate .= $this->dec($arr['hour']);							
						break;
					
				case 'G':// hour 0-24 
						$sDate .= $this->dec($arr['hour']);							
						break;
					
				case 'h':// hour 00-12 
						if($arr['hour'] >= 13 && $arr['hour'] <= 21) $sDate .= $this->inc($arr['hour']-12);
						elseif($arr['hour'] >= 22 && $arr['hour'] <= 23) $sDate .= $arr['hour']-12;
						else $sDate .= $arr['hour'];							
						break;
					
				case 'H':// hour 00-24 
						$sDate .= $arr['hour'];
						break;
					
				case 'i':// minute 00-59
						$sDate .= $arr['min'];
						break;
					
				case 'j':// day 0-31
						$sDate .= $this->dec($arr['day']);							
						break;
					
				case 'l':// week sunday-satrday
						$sDate .= $this->jDaysInWeek($arr['year'], $arr['month'], $arr['day'], 'name');
						break;
					
				case 'L':// year leap
						$sDate .= $this->jLeap($arr['year']);						
						break;
					
				case 'm':// month 00-12
						$sDate .= $arr['month'];						
						break;
					
				case 'n':// month 0-12
						$sDate .= $this->dec($arr['month']);							
						break;
					
				case 's':// second 00-59
						$sDate .= $arr['sec'];
						break;
					
				case 't':// month in day 
						if(($arr['month'] == 12) && $this->jLeap($arr['year'])) $sDate .= '30';
						else $sDate .= $this->rArray($arr['month']-1, 'jDaysInMonth');
						break;
					
				case 'w':// week [0-6]
						$sDate .= $this->jDaysInWeek($arr['year'], $arr['month'], $arr['day'], 'number');
						break;
					
				case 'W':// week number in year
						$arrFirst = array(0, 6, 5, 4, 3, 2, 1);
						$arrLast = array(1, 2, 3, 4, 5, 6, 0);
						$firstDay = $this->jDaysInWeek($arr['year'], 01, 01, 'number');
						$lastDay = $this->jDaysInWeek($arr['year'], $arr['month'], $arr['day'], 'number');
						$weekNumber = $this->jDayInYear($arr['month'], $arr['day']);
						$weekNumber = (int)((($weekNumber - $arrFirst[$firstDay]) - $arrLast[$lastDay]) / 7);
						if($firstDay != 0) ++$weekNumber; 
						if($lastDay != 6) ++$weekNumber;
						$sDate = $weekNumber; 						
						break;
					
				case 'y':// year in [YY]
						$sDate .= $this->dec($arr['year'], 2, false);
						break;
					
				case 'Y':// year in [YYYY]
						$sDate .= $arr['year'];
						break;
					
				case 'z':// day in year 
						$sDate .= $this->jDayInYear($arr['month'], $arr['day']); 
						break;
					
				default:
					$sDate .= $str[$i];
			}
		}
		
		return $sDate;
	}
	
	function rDateTime($type='Gregory')
	{
		$date = $this->rDate($type);
		return $date.' '.date('H:i:s');
	}
	
	function rDate($type='Gregory')
	{
		$date = date('Y-m-d');		
		if($type == 'Jalaly')			
			$date = $this->cDate($date);
			
		return $date;
	}
	
	function cDateTime($dateTime, $type='Gregory')
	{
		$date = substr($dateTime, 0, 10);
		$time = substr($dateTime, 11, 8);
		
		return $this->cDate($date, $type).' '.$time;
	}
	
	function cDate($date, $type='Gregory')
	{
		$date = explode('-', $date);
		
		if($type == 'Gregory')
			$arrDate = $this->gregoryAtJalaly($date[0], $date[1], $date[2]);
		elseif($type == 'Jalaly')
			$arrDate = $this->jalalyAtGregory($date[0], $date[1], $date[2]);
		
		return $arrDate['year'].'-'.$this->inc($arrDate['month']).'-'.$this->inc($arrDate['day']);
	}
	
	/*                                  private function for only use this class                                     */
	private function jLeap($year)
	{
		return (((((($year - (($year > 0) ? 474 : 473)) % 2820) + 474) + 38) * 682) % 2816) < 682;
	}
	
	private function dateDifference($dateTime, $new)
	{
		$dateTime = $this->dateTimIsArr($dateTime);
		$new = $this->dateTimIsArr($new);
		
		$sec = $new['sec'] - $dateTime['sec'];
		$min = $new['min'] - $dateTime['min'];
		$hour = $new['hour'] - $dateTime['hour'];
		$day = $new['day'] - $dateTime['day'];
		$month = $new['month'] - $dateTime['month'];
		$year = $new['year'] - $dateTime['year'];
		
		if($sec < 0)
		{
			$sec += 60;
			$min--;
		}
		if($sec > 59)
		{
			$sec -= 60;
			$min++;
		}
		if($min < 0)
		{
			$min += 60;
			$hour--;
		}
		if($min > 59)
		{
			$min -= 60;
			$hour++;
		}
		if($hour < 0)
		{
			$hour += 24;
			$day--;
		}
		if($hour > 23)
		{
			$hour -= 24;
			$day++;
		}
		if($day < 0)
		{
			$day += 30;
			$month--;
		}
		if($day > 30)
		{
			$day -= 30;
			$month++;
		}
		if($month < 0)
		{
			$month += 12;
			$year--;
		}
		if($month > 30)
		{
			$month -= 12;
			$year++;
		}	
		
		return $year.'-'.$this->inc($month).'-'.$this->inc($day).' '.$this->inc($hour).':'.$this->inc($min).':'.$this->inc($sec);
	}
	
	private function dateTimIsArr($dateTime)
	{
		list($arr['year'], $arr['month'], $arr['day']) = explode('-', substr($dateTime, 0, 10));
		list($arr['hour'], $arr['min'], $arr['sec']) = explode(':', substr($dateTime, 11));		
		return $arr;		
	}
		
	private function rArray($index, $arrName)
	{
		$jDaysInMonth = array(31, 31, 31, 31, 31, 31, 30, 30, 30, 30, 30, 29);
		$gDaysInMonth = array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
		$jNameOfDaysInWeek = array('شنبه', 'یکشنبه', 'دوشنبه', 'سه شنبه', 'چهارشنبه', 'پنج شنبه', 'جمعه');
		$jNameOfMonths = array(1=>'فروردین', 2=>'اردیبهشت', 3=>'خرداد',4=>'تیر', 5=>'مرداد', 6=>'شهریور', 
							7=>'مهر', 8=>'آبان', 9=>'آذر', 10=>'دی', 11=>'بهمن', 12=>'اسفند');
							
		switch($arrName)
		{
			case 'jDaysInMonth':	
				$rArray = $jDaysInMonth[(int)$index];
				break;
			case 'gDaysInMonth':	
				$rArray = $gDaysInMonth[(int)$index];
				break;
			case 'jNameOfDaysInWeek':	
				$rArray = $jNameOfDaysInWeek[(int)$index];
				break;
			case 'jNameOfMonths':	
				$rArray = $jNameOfMonths[(int)$index];
				break;
		}
		return $rArray;
	}
	
	private function jDaysInWeek($year, $month, $day, $type)
	{
		$jDaysInWeek = date('w', $this->jMKTime($year, $month, $day))+1;
		if($jDaysInWeek == 7) 
			$jDaysInWeek = 0;
		if($type == 'name')
			$jDaysInWeek = $this->rArray($jDaysInWeek, 'jNameOfDaysInWeek');
		return $jDaysInWeek;
	}
	
	private function jDayInYear($month, $day)
	{
		for($i=0; $i<($month-1); $i++)
			$jDayInYear += $this->rArray($i, 'jDaysInMonth');
		return $jDayInYear + $day;
	}
	
	private function jMKTime($year, $month, $day, $hour=0, $min=0, $sec=0)
	{
		$jMKTime = $this->jalalyAtGregory($year, $month, $day);
		return mktime($hour, $min, $sec, $jMKTime['month'], $jMKTime['day'], $jMKTime['year']);
	}
	
	private function dec($str, $dec=1, $form='^0')
	{
		if($form)
		{
			if(ereg($form, $str))
				$str = substr($str, (strlen($str)-(int)$dec));
		}
		else
			$str = substr($str, (strlen($str)-(int)$dec));
						
		return $str;
	}
	
	private function inc($str, $inc=2)
	{
		$inc -= strlen($str);
		for($i=0; $i<$inc; $i++)
			$str = '0'.$str;			
		return $str;
	}
	
	/*                          is convertor to and from Gregorian and Jalali calendars.
                                Copyright (C) 2000 Roozbeh Pournader and Mohammad Toossi.                                  */
	private function div($a,$b)
	{
		 return (int) ($a / $b);
	}
	
	private function gregoryAtJalaly($year, $month, $day)
	{
		$year -= 1600;
		$month--;
		$day--;
		
		$gDayNo = 365*$year+$this->div($year+3,4)-$this->div($year+99,100)+$this->div($year+399,400);
		
		for ($i=0; $i < $month; $i++)
			$gDayNo += $this->rArray($i, 'gDaysInMonth');
		
		if (($this->jLeap($year)) && $month > 1)
			$gDayNo++;
			
		$gDayNo += $day;
		
		$jDayNo = $gDayNo-79;
		$j_np = $this->div($jDayNo, 12053); 
		$jDayNo %= 12053;
		$year = 979+33*$j_np+4*$this->div($jDayNo,1461); 
		$jDayNo %= 1461;
		
		if ($jDayNo >= 366) 
		{
			$year += $this->div($jDayNo-1, 365);
			$jDayNo = ($jDayNo-1)%365;
		}
		
		for ($i = 0; $i < 11 && $jDayNo >= $this->rArray($i, 'jDaysInMonth'); ++$i)
			$jDayNo -= $this->rArray($i, 'jDaysInMonth');
			
		$month = $i+1;
		$day = $jDayNo+1;
		
		return array('year'=>$year, 'month'=>$month, 'day'=>$day);
	}
	
	private function jalalyAtGregory($year, $month, $day)
	{
		$year -= 979;
		$month--;
		$day--;
		
		$jDayNo = 365*$year + $this->div($year, 33)*8 + $this->div($year%33+3, 4);
		for ($i=0; $i < $month; ++$i)
			$jDayNo += $this->rArray($i, 'jDaysInMonth');
		$jDayNo += $day;
		
		$gDayNo = $jDayNo+79;
		$year = 1600 + 400*$this->div($gDayNo, 146097); 
		$gDayNo = $gDayNo % 146097;
		$leap = true;
		if ($gDayNo >= 36525) 
		{
			$gDayNo--;
			$year += 100*$this->div($gDayNo, 36524); 
			$gDayNo = $gDayNo % 36524;
			if ($gDayNo >= 365)
				$gDayNo++;
			else
				$leap = false;
		}
		$year += 4*$this->div($gDayNo, 1461); 
		$gDayNo %= 1461;
		if ($gDayNo >= 366) 
		{
			$leap = false;
			$gDayNo--;
			$year += $this->div($gDayNo, 365);
			$gDayNo = $gDayNo % 365;
		}
		for ($i = 0; $gDayNo >= $this->rArray($i, 'gDaysInMonth') + ($i == 1 && $leap); $i++)
			$gDayNo -= $this->rArray($i, 'gDaysInMonth') + ($i == 1 && $leap);
		$month = $i+1;
		$day = $gDayNo+1;
		
		return array('year'=>$year, 'month'=>$month, 'day'=>$day);
	}
	
}
?>