#************************************************
#SLAED CMS 1.2 : Content Management System
#http://www.slaed.ir
#Developed By Mohammad Reza Mahmoudi 
#mrezam2pm@gmail.com
#Copyright (c) 2005-2010 By Slaed.ir
#************************************************

CREATE TABLE `{pref}_admins` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(67) NOT NULL default '',
  `title` varchar(50) default NULL,
  `url` varchar(255) NOT NULL default '',
  `email` varchar(255) NOT NULL default '',
  `pwd` varchar(40) default NULL,
  `super` tinyint(1) default NULL,
  `modules` varchar(255) NOT NULL default '',
  `lang` varchar(30) NOT NULL default '',
  `ip` varchar(15) default NULL,
  `regdate` datetime NOT NULL,
  `lastvisit` datetime NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `{pref}_blocks` (
  `bid` int(10) NOT NULL auto_increment,
  `bkey` varchar(15) NOT NULL default '',
  `title` varchar(255) NOT NULL default '',
  `content` MEDIUMTEXT NOT NULL,
  `url` varchar(200) NOT NULL default '',
  `bposition` char(1) NOT NULL default '',
  `weight` int(10) NOT NULL default '1',
  `active` int(1) NOT NULL default '1',
  `refresh` int(10) NOT NULL default '0',
  `time` varchar(14) NOT NULL default '0',
  `blanguage` varchar(30) NOT NULL default '',
  `blockfile` varchar(255) NOT NULL default '',
  `view` int(1) NOT NULL default '0',
  `expire` varchar(14) NOT NULL default '0',
  `action` char(1) NOT NULL default '',
  `which` text NOT NULL,
  PRIMARY KEY (`bid`),
  KEY `title` (`title`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `{pref}_categories` (
  `id` int(11) NOT NULL auto_increment,
  `modul` varchar(50) NOT NULL default '',
  `title` varchar(255) NOT NULL default '',
  `description` MEDIUMTEXT NOT NULL,
  `img` varchar(100) NOT NULL default '',
  `language` varchar(30) NOT NULL default '',
  `parentid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `modul` (`modul`),
  KEY `parentid` (`parentid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `{pref}_comment` (
  `id` int(11) NOT NULL auto_increment,
  `cid` int(11) NOT NULL default '0',
  `modul` varchar(60) NOT NULL default '',
  `date` datetime default NULL,
  `uid` int(11) NOT NULL default '0',
  `name` varchar(67) NOT NULL default '',
  `host_name` varchar(60) default NULL,
  `comment` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `cid` (`cid`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `{pref}_content` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(100) default NULL,
  `text` mediumtext NOT NULL,
  `field` text NOT NULL,
  `url` varchar(200) NOT NULL default '',
  `time` datetime default NULL,
  `refresh` int(10) NOT NULL default '0',
  `counter` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `counter` (`counter`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE `{pref}_groups` (
  `id` int(10) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `points` int(10) NOT NULL default '0',
  `extra` int(1) NOT NULL default '0',
  `rank` varchar(255) NOT NULL default '',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `{pref}_message` (
  `mid` int(11) NOT NULL auto_increment,
  `title` varchar(100) NOT NULL default '',
  `content` text NOT NULL,
  `expire` int(7) NOT NULL default '0',
  `active` int(1) NOT NULL default '1',
  `view` int(1) NOT NULL default '1',
  `mlanguage` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`mid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE `{pref}_modules` (
  `mid` int(11) NOT NULL auto_increment,
  `title` varchar(50) NOT NULL default '',
  `custom_title` varchar(67) NOT NULL default '',
  `active` int(1) NOT NULL default '0',
  `view` int(1) NOT NULL default '0',
  `inmenu` tinyint(1) NOT NULL default '1',
  `mod_group` int(10) default '0',
  `blocks` int(1) NOT NULL default '0',
  `blocks_c` int(1) NOT NULL default '0',
  PRIMARY KEY (`mid`),
  KEY `title` (`title`),
  KEY `custom_title` (`custom_title`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `{pref}_session` (
  `uname` varchar(67) NOT NULL default '',
  `time` varchar(14) NOT NULL default '',
  `host_addr` varchar(15) NOT NULL default '',
  `guest` int(1) NOT NULL default '0',
  `module` varchar(100) NOT NULL default '',
  `url` varchar(255) NOT NULL default '',
  PRIMARY KEY (`time`),
  KEY `guest` (`guest`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `{pref}_stories` (
  `sid` int(11) NOT NULL auto_increment,
  `catid` int(11) NOT NULL default '0',
  `uid` int(11) NOT NULL default '0',
  `name` varchar(25) NOT NULL default '',
  `title` varchar(255) default NULL,
  `time` datetime default NULL,
  `hometext` text,
  `bodytext` text NOT NULL,
  `field` text NOT NULL,
  `comments` int(11) default '0',
  `counter` int(11) NOT NULL default '0',
  `ihome` int(1) NOT NULL default '0',
  `acomm` int(1) NOT NULL default '0',
  `score` int(11) NOT NULL default '0',
  `ratings` int(11) NOT NULL default '0',
  `associated` text NOT NULL,
  `ip_sender` varchar(60) default NULL,
  `status` int(1) NOT NULL default '0',
  PRIMARY KEY  (`sid`),
  KEY `catid` (`catid`),
  KEY `counter` (`counter`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE `{pref}_survey` (
  `poll_id` int(11) NOT NULL auto_increment,
  `poll_date` datetime default NULL,
  `poll_title` varchar(255) NOT NULL default '',
  `poll_questions` text NOT NULL,
  `poll_answer_1` int(11) NOT NULL default '0',
  `poll_answer_2` int(11) NOT NULL default '0',
  `poll_answer_3` int(11) NOT NULL default '0',
  `poll_answer_4` int(11) NOT NULL default '0',
  `poll_answer_5` int(11) NOT NULL default '0',
  `poll_answer_6` int(11) NOT NULL default '0',
  `poll_answer_7` int(11) NOT NULL default '0',
  `poll_answer_8` int(11) NOT NULL default '0',
  `poll_answer_9` int(11) NOT NULL default '0',
  `poll_answer_10` int(11) NOT NULL default '0',
  `poll_answer_11` int(11) NOT NULL default '0',
  `poll_answer_12` int(11) NOT NULL default '0',
  `pool_vote` int(11) NOT NULL default '0',
  `pool_comments` int(11) NOT NULL default '0',
  `planguage` varchar(30) NOT NULL default '',
  `acomm` int(1) NOT NULL default '0',
  PRIMARY KEY (`poll_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `{pref}_rating` (
  `id` int(11) NOT NULL auto_increment,
  `mid` int(11) NOT NULL default '0',
  `modul` varchar(50) NOT NULL default '',
  `time` varchar(14) NOT NULL default '',
  `uid` int(11) NOT NULL default '0',
  `host` varchar(60) default NULL,
  PRIMARY KEY (`id`),
  KEY `mid` (`mid`),
  KEY `modul` (`modul`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `{pref}_users` (
  `user_id` int(11) NOT NULL auto_increment,
  `user_name` varchar(67) NOT NULL default '',
  `user_email` varchar(255) NOT NULL default '',
  `user_website` varchar(255) NOT NULL default '',
  `user_avatar` varchar(255) NOT NULL default '',
  `user_regdate` datetime NOT NULL,
  `user_icq` varchar(15) default NULL,
  `user_occ` varchar(100) default NULL,
  `user_from` varchar(100) default NULL,
  `user_interests` varchar(150) NOT NULL default '',
  `user_sig` varchar(255) default NULL,
  `user_viewemail` tinyint(1) default NULL,  
  `user_aim` varchar(18) default NULL,
  `user_yim` varchar(67) default NULL,
  `user_msnm` varchar(25) default NULL,
  `user_password` varchar(32) NOT NULL default '',
  `user_storynum` tinyint(4) NOT NULL default '10',
  `user_blockon` tinyint(1) NOT NULL default '0',
  `user_block` tinytext NOT NULL,
  `user_theme` varchar(255) NOT NULL default '',  
  `user_newsletter` int(1) NOT NULL default '0',
  `user_lastvisit` datetime NOT NULL,
  `user_lang` varchar(255) NOT NULL default 'russian',  
  `user_points` int(10) default '0',
  `user_last_ip` varchar(15) NOT NULL default '0',
  `user_warnings` int(5) NOT NULL default '0',
  `user_group` int(1) NOT NULL default '0',
  `user_birthday` date default NULL,
  `user_gender` int(1) NOT NULL default '0',
  `user_votes` int(11) NOT NULL default '0',
  `user_totalvotes` int(11) NOT NULL default '0',
  `user_field` text NOT NULL,
  `user_agent` varchar(255) NOT NULL default '',
  PRIMARY KEY (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `{pref}_users_temp` (
  `user_id` int(10) NOT NULL auto_increment,
  `user_name` varchar(67) NOT NULL default '',
  `user_email` varchar(255) NOT NULL default '',
  `user_password` varchar(25) NOT NULL default '',
  `user_regdate` datetime NOT NULL,
  `check_num` varchar(50) NOT NULL default '',
  `time` varchar(14) NOT NULL default '',
  PRIMARY KEY (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;